var _baseHost = "http://39.100.71.89";
// var _baseHost = "https://app.youjilp.com";
var _baseUrl = _baseHost +"/mobile";
//var _imUrl = _baseHost +"/ugMall-IM";

// var _baseHost = "http://39.152.0.156:58082";
// var _baseUrl = _baseHost +"/mobile";

// var _baseHost = "http://192.168.122.18:38080";
// var _baseUrl = _baseHost +"/mobile";

var wgtVer=null; //版本号

!(function (doc, win) {
    var el = doc.documentElement;
    //resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize';

    function setSize() {
        var w = el.clientWidth;
        if (!w) return;
        w=w>480?480:w;
        w=w<320?320:w;
        el.style.fontSize = (100 * (w / 1080)).toFixed(3) + 'px';
    }
    if (!doc.addEventListener) return;
    setSize();
    win.addEventListener('resize', setSize, false);
    win.addEventListener('pageshow', function(e) {
         if (e.persisted) {
            setSize();
         }
    }, false);
})(document, window);

(function($, owner) {
	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 存储应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
		}

}(mui, window.app = {}));

//判断是否为空对象
function isEmpty(v) {
    switch (typeof v) {
    case 'undefined':
        return true;
    case 'string':
        if (v.replace(/(^[ \t\n\r]*)|([ \t\n\r]*$)/g, '').length == 0) return true;
        break;
    case 'boolean':
        if (!v) return true;
        break;
    case 'number':
        if (0 === v || isNaN(v)) return true;
        break;
    case 'object':
        if (null === v || v.length === 0) return true;
        for (var i in v) {
            return false;
        }
        return true;
    }
    return false;
}
//存储商品id和type
function setGoods(id,type) {
	plus.storage.setItem("goodsId",id+"");
	plus.storage.setItem("goodsType",type+"");
}

//存储地址
function setAddressDetail(type,id,receiverName,receiverPhone,address) {
	plus.storage.setItem("addressType",type+"");
	plus.storage.setItem("addressId",id+"");
	plus.storage.setItem("addressReceiverName",receiverName+"");
	plus.storage.setItem("addressReceiverPhone",receiverPhone+"");
	plus.storage.setItem("addressDetail",address+"");
}

//存储订单
function setOrder(objStr) {
	plus.storage.setItem("order", objStr+"");
}

//存储公告
function setNotice(title, url) {
	plus.storage.setItem("noticeTitle",title+"");
	plus.storage.setItem("noticeUrl",url+"");
}

//存储任务
function setTask(id, title, url) {
	plus.storage.setItem("taskId",id+"");
	plus.storage.setItem("taskTitle",title+"");
	plus.storage.setItem("taskUrl",url+"");
}

//存储邀请
function setInvitor(invitor) {
	plus.storage.setItem("invitor",invitor+"");
}

//支付订单
function payOrder(orderType, orderCode, orderAmount) {
	plus.storage.setItem("orderType",orderType+"");
	plus.storage.setItem("orderCode",orderCode+"");
	plus.storage.setItem("orderAmount",orderAmount+"");
	if(orderType=="代理"){
		plus.storage.setItem("orderAction","payAgentOrder");
		location.href="order-submit.html";
	} else if(orderType=="零售"){
		plus.storage.setItem("orderAction","paySalesOrder");
		location.href="order-submit.html";
	} else if(orderType=="积分"){
		plus.storage.setItem("orderAction","payPointOrder");
		location.href="point-order-submit.html";
	}
}
//取消订单
function cancelOrder(orderType, orderCode){
	var bts=["是","否"];
	plus.nativeUI.confirm('请确认是否取消订单？',function(e){
		if(e.index==0){
			var url = "";
			if(orderType=="代理"){
				url = _baseUrl + "/cancelAgentOrder";
			} else if(orderType=="零售"){
				url = _baseUrl + "/cancelSalesOrder";
			} else if(orderType=="积分"){
				url = _baseUrl + "/cancelPointOrder";
			}
			mui.ajax({
				type: "get",
				url: url,
				data: { orderCode:orderCode },
				async: true,
				dataType: "json",
				success: function(data) {
					console.log(JSON.stringify(data));
					if (data.code == "500") {
						mui.toast(data.msg);
					} else {
						location.href="order-topay.html";
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('请稍后再试');
				}
			});
		} else {
		}
	},"订单确认",bts);
}
//申请退款
function applyRefund(orderType, orderCode){
	if(orderType=="积分"){
		mui.toast('积分兑换不支持退款');
		return;
	}
	var bts=["是","否"];
	plus.nativeUI.confirm('请确认是否申请退款？',function(e){
		if(e.index==0){
			mui.ajax({
				type: "get",
				url: _baseUrl + "/applyRefund",
				data: { orderCode:orderCode },
				async: true,
				dataType: "json",
				success: function(data) {
					console.log(JSON.stringify(data));
					if (data.code == "500") {
						mui.toast(data.msg);
					} else {
						location.href="order-all.html";
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('请稍后再试');
				}
			});
		} else {
		}
	},"退款确认",bts);
}

//确认收货
function finishSalesOrder(orderType, orderCode){
	alert(orderType);
	var bts=["确定","取消"];
	plus.nativeUI.confirm("请确认是否收到货物？",function(e){
		if(e.index==0){
			var url = "";
			if(orderType=="积分"){
				url = _baseUrl + "/finishPointOrder";
			} else {
				url = _baseUrl + "/finishSalesOrder";
			}
			mui.ajax({
				type: "get",
				url: url,
				data: { orderCode:orderCode },
				async: true,
				dataType: "json",
				success: function(data) {
					console.log(JSON.stringify(data));
					if (data.code == "500") {
						mui.toast(data.msg);
					} else {
						location.href="order-all.html";
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('请稍后再试');
				}
			});
		}
	},"收货提醒",bts);
}
//查看自提码
function showSalesCode(orderType,orderCode,salesCode){
	plus.storage.setItem("orderType",orderType+"");
	plus.storage.setItem("orderCode",orderCode+"");
	plus.storage.setItem("salesCode",salesCode+"");
	location.href="order-receipt-qrcode.html";
}

//领取任务
function drawTask(agentGrade, taskId) {
	var w = plus.nativeUI.showWaiting();
    mui.ajax({
		type: "get",
		url: _baseUrl + "/drawTask",
		data: { taskId:taskId,agentGrade:agentGrade },
		async: false,
		dataType: "json",
		success: function(data) {
			console.log(JSON.stringify(data));
			mui.toast(data.msg);
			w.close();
			w = null;
			location.reload();
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('请稍后再试');
			w.close();
			w = null;
			location.reload();
		}
	});
}
//订单详情
function orderDetail(orderCode){
	plus.storage.setItem("orderDetailCode",orderCode+"");
	location.href="order-detail.html";
}

//申请回购
function settlementAccount(agentGrade, buyBackTime, orderCode) {
	buyBackTime = buyBackTime.replace(/-/g,'/');
	if(new Date()<=new Date(buyBackTime)) {
		plus.nativeUI.alert("可回购日期为"+buyBackTime);
		return;
	}
	var bts=["确定","取消"];
	plus.nativeUI.confirm("如不回购将继续享受每日奖励，确认是否回购？",function(e){
		if(e.index==0){
		    mui.ajax({
				type: "post",
				url: _baseUrl + "/settlementAccount",
				data: {"agentGrade":agentGrade, "orderCode":orderCode},
				async: false,
				dataType: "json",
				success: function(data) {
					console.log(JSON.stringify(data));
					mui.toast(data.msg);
					if (data.code == "500") {
					} else {
						location.reload();
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('请稍后再试');
					return false;
				}
			});
		}
	},"回购提醒",bts);
}

//客服功能
function openIM(type) {
	location.href="im-wx.html"
	/*
    if(plus.webview.getWebviewById('im.html')==null) {
		//启动客服后台进程
		mui.ajax({
			type: "get",
			url: _baseUrl + "/getUserInfo",
			data: {},
			dataType: "json",
			success: function(data) {
				console.log(JSON.stringify(data));
				if (data.code == "500") {
	   				mui.toast("您的账号未授权或已在别处登录！");  
				} else {
					// 0顾客1内部人员 默认设置为0
					plus.storage.setItem("keyType","0");
                    mui.each(data, function(i, n) {
						switch(n.agentGrade) {
						    case "客服组":
								plus.storage.setItem("keyType","1");// 0顾客1内部人员
						        break;
						    default:
						        break;
						}
                    });
					clicked2('im.html',true);
					if(type=="1") {
						plus.webview.getWebviewById('im.html').show('pop-in');
					} else {
						plus.webview.getWebviewById('im.html').hide();
					}
				}
			}
		});
   } else {
		if(type=="1") {
			plus.webview.getWebviewById('im.html').show('pop-in');
		} else {
			plus.webview.getWebviewById('im.html').hide();
		}
    }
	*/
}

// 检测更新
function checkUpdate(){  
	plus.nativeUI.showWaiting("检测更新...");  
	var xhr=new XMLHttpRequest();  
	xhr.onreadystatechange=function(){  
	    switch(xhr.readyState){  
	        case 4:  
	        plus.nativeUI.closeWaiting();  
	        if(xhr.status==200){  
	            console.log("检测更新成功："+xhr.responseText);
	            var data = JSON.parse(xhr.responseText).appVersion[0];
	            var newVer=data.appVersion;  
	            if(wgtVer&&newVer&&(wgtVer!=newVer)){
					plus.nativeUI.alert("检查到新版本："+newVer+"，请升级！",function(e){
				        if(data.type=="wgt") {
		                		downWgt(data.wgtUrl);  // 下载升级包  
				        } else {  
					        switch ( plus.os.name ) {  
						        case "Android":
		                			plus.runtime.openURL(data.androidUrl);  // 下载升级包  
									break;  
						        case "iOS":  
									plus.runtime.openURL(data.iosUrl);
									break;  
						        default:  
									// 其它平台  
									break;  
						    }
				        }
					},"升级提示");
	            }else{
	                mui.toast("无新版本可更新！");  
	            }  
	        }else{  
	            console.log("检测更新失败！");  
	            mui.toast("检测更新失败！");  
	        }  
	        break;  
	        default:  
	        break;  
	    }  
	}  
	xhr.open('GET', _baseUrl + "/appVersion");  
	xhr.send();  
}
// 下载wgt文件
function downWgt(wgtUrl){  
	plus.nativeUI.showWaiting("下载升级包...");  
	plus.downloader.createDownload( wgtUrl, {filename:"_doc/update/"}, function(d,status){  
	    if ( status == 200 ) {   
	        console.log("下载wgt成功："+d.filename);  
	        installWgt(d.filename); // 安装wgt包  
	    } else {  
	        console.log("下载wgt失败！");  
	        mui.toast("下载升级包失败！");  
	    }  
	    plus.nativeUI.closeWaiting();  
	}).start();  
}
// 更新应用资源  
function installWgt(path){  
	plus.nativeUI.showWaiting("安装升级包...");  
	plus.runtime.install(path,{},function(){  
	    plus.nativeUI.closeWaiting();  
	    console.log("安装wgt文件成功！");  
	    mui.toast("应用资源更新完成！");
	    plus.runtime.restart();  
//	    mui.toast("应用资源更新完成！",function(){  
//	        plus.runtime.restart();  
//	    });  
	},function(e){  
	    plus.nativeUI.closeWaiting();  
	    console.log("安装wgt文件失败["+e.code+"]："+e.message);  
	    mui.toast("安装升级包失败["+e.code+"]，请尝试卸载后重新安装");  
	});  
}

//图片加载===============================================
// md5.mini.js
!function(a){"use strict";function b(a,b){var c=(65535&a)+(65535&b),d=(a>>16)+(b>>16)+(c>>16);return d<<16|65535&c}function c(a,b){return a<<b|a>>>32-b}function d(a,d,e,f,g,h){return b(c(b(b(d,a),b(f,h)),g),e)}function e(a,b,c,e,f,g,h){return d(b&c|~b&e,a,b,f,g,h)}function f(a,b,c,e,f,g,h){return d(b&e|c&~e,a,b,f,g,h)}function g(a,b,c,e,f,g,h){return d(b^c^e,a,b,f,g,h)}function h(a,b,c,e,f,g,h){return d(c^(b|~e),a,b,f,g,h)}function i(a,c){a[c>>5]|=128<<c%32,a[(c+64>>>9<<4)+14]=c;var d,i,j,k,l,m=1732584193,n=-271733879,o=-1732584194,p=271733878;for(d=0;d<a.length;d+=16)i=m,j=n,k=o,l=p,m=e(m,n,o,p,a[d],7,-680876936),p=e(p,m,n,o,a[d+1],12,-389564586),o=e(o,p,m,n,a[d+2],17,606105819),n=e(n,o,p,m,a[d+3],22,-1044525330),m=e(m,n,o,p,a[d+4],7,-176418897),p=e(p,m,n,o,a[d+5],12,1200080426),o=e(o,p,m,n,a[d+6],17,-1473231341),n=e(n,o,p,m,a[d+7],22,-45705983),m=e(m,n,o,p,a[d+8],7,1770035416),p=e(p,m,n,o,a[d+9],12,-1958414417),o=e(o,p,m,n,a[d+10],17,-42063),n=e(n,o,p,m,a[d+11],22,-1990404162),m=e(m,n,o,p,a[d+12],7,1804603682),p=e(p,m,n,o,a[d+13],12,-40341101),o=e(o,p,m,n,a[d+14],17,-1502002290),n=e(n,o,p,m,a[d+15],22,1236535329),m=f(m,n,o,p,a[d+1],5,-165796510),p=f(p,m,n,o,a[d+6],9,-1069501632),o=f(o,p,m,n,a[d+11],14,643717713),n=f(n,o,p,m,a[d],20,-373897302),m=f(m,n,o,p,a[d+5],5,-701558691),p=f(p,m,n,o,a[d+10],9,38016083),o=f(o,p,m,n,a[d+15],14,-660478335),n=f(n,o,p,m,a[d+4],20,-405537848),m=f(m,n,o,p,a[d+9],5,568446438),p=f(p,m,n,o,a[d+14],9,-1019803690),o=f(o,p,m,n,a[d+3],14,-187363961),n=f(n,o,p,m,a[d+8],20,1163531501),m=f(m,n,o,p,a[d+13],5,-1444681467),p=f(p,m,n,o,a[d+2],9,-51403784),o=f(o,p,m,n,a[d+7],14,1735328473),n=f(n,o,p,m,a[d+12],20,-1926607734),m=g(m,n,o,p,a[d+5],4,-378558),p=g(p,m,n,o,a[d+8],11,-2022574463),o=g(o,p,m,n,a[d+11],16,1839030562),n=g(n,o,p,m,a[d+14],23,-35309556),m=g(m,n,o,p,a[d+1],4,-1530992060),p=g(p,m,n,o,a[d+4],11,1272893353),o=g(o,p,m,n,a[d+7],16,-155497632),n=g(n,o,p,m,a[d+10],23,-1094730640),m=g(m,n,o,p,a[d+13],4,681279174),p=g(p,m,n,o,a[d],11,-358537222),o=g(o,p,m,n,a[d+3],16,-722521979),n=g(n,o,p,m,a[d+6],23,76029189),m=g(m,n,o,p,a[d+9],4,-640364487),p=g(p,m,n,o,a[d+12],11,-421815835),o=g(o,p,m,n,a[d+15],16,530742520),n=g(n,o,p,m,a[d+2],23,-995338651),m=h(m,n,o,p,a[d],6,-198630844),p=h(p,m,n,o,a[d+7],10,1126891415),o=h(o,p,m,n,a[d+14],15,-1416354905),n=h(n,o,p,m,a[d+5],21,-57434055),m=h(m,n,o,p,a[d+12],6,1700485571),p=h(p,m,n,o,a[d+3],10,-1894986606),o=h(o,p,m,n,a[d+10],15,-1051523),n=h(n,o,p,m,a[d+1],21,-2054922799),m=h(m,n,o,p,a[d+8],6,1873313359),p=h(p,m,n,o,a[d+15],10,-30611744),o=h(o,p,m,n,a[d+6],15,-1560198380),n=h(n,o,p,m,a[d+13],21,1309151649),m=h(m,n,o,p,a[d+4],6,-145523070),p=h(p,m,n,o,a[d+11],10,-1120210379),o=h(o,p,m,n,a[d+2],15,718787259),n=h(n,o,p,m,a[d+9],21,-343485551),m=b(m,i),n=b(n,j),o=b(o,k),p=b(p,l);return[m,n,o,p]}function j(a){var b,c="";for(b=0;b<32*a.length;b+=8)c+=String.fromCharCode(a[b>>5]>>>b%32&255);return c}function k(a){var b,c=[];for(c[(a.length>>2)-1]=void 0,b=0;b<c.length;b+=1)c[b]=0;for(b=0;b<8*a.length;b+=8)c[b>>5]|=(255&a.charCodeAt(b/8))<<b%32;return c}function l(a){return j(i(k(a),8*a.length))}function m(a,b){var c,d,e=k(a),f=[],g=[];for(f[15]=g[15]=void 0,e.length>16&&(e=i(e,8*a.length)),c=0;16>c;c+=1)f[c]=909522486^e[c],g[c]=1549556828^e[c];return d=i(f.concat(k(b)),512+8*b.length),j(i(g.concat(d),640))}function n(a){var b,c,d="0123456789abcdef",e="";for(c=0;c<a.length;c+=1)b=a.charCodeAt(c),e+=d.charAt(b>>>4&15)+d.charAt(15&b);return e}function o(a){return unescape(encodeURIComponent(a))}function p(a){return l(o(a))}function q(a){return n(p(a))}function r(a,b){return m(o(a),o(b))}function s(a,b){return n(r(a,b))}function t(a,b,c){return b?c?r(b,a):s(b,a):c?p(a):q(a)}"function"==typeof define&&define.amd?define(function(){return t}):a.md5=t}(this);
//设置背景图时,去掉图片灰色边框,第一次使用请检查路径是否正确!!
var img_translate="img/translate.png";

var taskArr = new Array(); //图片下载任务集合
var isStartTask = false; //是否开启下载任务

/**
 * 通过设置src默认图,来触发onload的方法
 * 如果本地不存在,则联网下载,保存至本地
 * 如果本地存在,则直接显示
 * 
 * 所以src默认图,必须设置,否则无法触发onload;
 * 格式如下:
 * <img src='默认图片' data-src='网络地址' onload='load(this)'/>
 */
function load(obj) {
	if (obj.getAttribute('data-loaded')) return;
	var image_url = obj.getAttribute('data-src');
	if (!image_url) return;
	//本地缓存路径
	var hb_path = '_downloads/image/' + md5(image_url) + '.jpg'; //HBuilder平台路径
	var sd_path = plus.io.convertLocalFileSystemURL(hb_path); //SD卡绝对路径
	
	//temp用于判断图片文件是否存在
	var temp = new Image();
	temp.src = sd_path;
	temp.onload = function() {
		// 1存在, 则直接显示
		console.log('已存在,直接显示==' + hb_path);
		setLoaded(obj,sd_path);
	};
	temp.onerror = function() {
		// 2不存在, 则下载图片
		console.log('不存在==' + hb_path);
		//为避免下载出错或下载超时过长,先用src加载图显示
		var temp = new Image();
		temp.onload = function() {
			setLoaded(obj, image_url); //设置图片
		};
		temp.src = image_url;
		//添加图片下载任务
		//(本来打算先检查图片是否已在任务队列中,如果存在则不加入;但是可能图刚加入时就被取出,导致后面相同的图又重复加入,出现本地图存在,下载无回调的问题)
		obj.setAttribute('hb_path', hb_path);
		obj.setAttribute('sd_path', sd_path);
		taskArr.push(obj);
		//启动下载
		if (!isStartTask) {
			isStartTask = true;
			startTask();
		}
	};
}

/**
 * 图片任务下载 
 * 递归调用方式保持只有一个downloader在下载,避免批量创建downloader手机发烫
 */
function startTask() {
	if (taskArr.length == 0) {
		isStartTask = false;
		return;
	}
	//从任务集合中取一个任务
	var obj = taskArr.shift();
	var image_url = obj.getAttribute('data-src');
	var hb_path = obj.getAttribute('hb_path');
	var sd_path=obj.getAttribute('sd_path');
	console.log("从任务集合中取一个任务==" + hb_path);
	//检查是否已经下载过,避免downloader文件存在时无回调,手机发烫;
	//(本来打算先检查图片是否已在任务队列中,如果存在则不加入;但是可能图刚加入时就被取出,导致后面相同的图又重复加入,出现本地图存在,下载无回调的问题)
	var temp = new Image();
	temp.src = sd_path;
	temp.onload = function() {
		//已下载则跳过
		console.log("已下载则跳过==" + hb_path);
		startTask();
	};
	temp.onerror = function() {
		//执行下载
		var task = plus.downloader.createDownload(image_url, {
			"filename": hb_path,
			"timeout": 10,
			"retry": 2
		}, function(download, status) {
			console.log("下载回调status==" + status+"-->"+hb_path);
			if (status == 200) {
				setLoaded(obj,sd_path);
			}else{
				//下载失败,取消下载任务,需删除本地临时文件,否则下次进来时会检查到图片已存在
				//download.abort();取消任务,但有时会删除文件失败,固使用delFile(hb_path)先进行删除
				delFile(hb_path);
				download.abort();
			}
			//继续下载
			startTask();
		});
		task.start();
	};
}

/*给<img>设置背景,标志加载成功*/
function setLoaded(obj,bg_url) {
	if (obj.getAttribute("data-loaded")) return;
	
	obj.classList.add("anim_opacity"); //渐变动画
	obj.setAttribute("data-loaded", true);//标记成功
	obj.setAttribute("src",bg_url);
//	obj.setAttribute("src",img_translate); //去掉灰色边,只有背景图才可居中铺满图片
//	obj.style.backgroundImage = "url(" + bg_url + ")"; //背景
}

/*删除指定文件*/
function delFile(hb_path) {
	if (hb_path) {
		plus.io.resolveLocalFileSystemURL(hb_path, function(entry) {
			entry.remove(function(entry) {
				console.log("文件删除成功==" + hb_path);
			}, function(e) {
				console.log("文件删除失败=" + hb_path);
			});
		});
	}
}